if($ARGV[0]) {
    $TodayYMD = $ARGV[0];
} else {
    &SetTimeValue;
}

# \Est@C
$IssuedListFile = $IssuedListFileHeader . $TodayYMD . ".dat";        # PC\p
$IssuedListFileP = $IssuedListFileHeader . "p" . $TodayYMD . ".dat"; # PCsp
$IssuedListFileC = $IssuedListFileHeader . "c" . $TodayYMD . ".dat"; # gєsp

$RegulatedLogFile = $IssuedListFileHeader . "rl" . $TodayYMD . ".dat"; # KO
$RegulatedHostFile = $IssuedListFileHeader . "rg" . $TodayYMD . ".dat"; # KHostXg

$CodeListFile = "code" . $TodayYMD . ".html";
$CodeCheckFile = "codecheck" . $TodayYMD . ".dat";

$CellNewcomerFile = "cell" . $TodayYMD . ".dat";

$MMDD = $TodayYMD;
$MMDD =~ s/.*(\d\d\d\d)$/$1/;

%colors = ("46051S1)" => "#DDFFFF",
	   "46051S1N4)" => "#CCEEFF",
#	   "46051S1N3N4)" => "#CCCCFF",
	   "47051)" => "#DDEEFF",
#	   "46051N4)" => "#BBEEFF",
	   "46050N4)" => "#CCFFEE",
#	   "47060; GTB5SL1N" => "#EEFFDD",
	   "46051S1N45)" => "#AAFFFF",
	   "47051N45N36)" => "#EEFFEE",
	   "47060G5SL1N57M5" => "#C0F0E0",
#	   "46098)" => "#FFDDFF",
	   "47060G6SL1N57M5" => "#EEFFDD",
#	   "47051T4N57N32N3" => "#CCCCFF",
	   "475TN729)" => "#CCCCFF",
#	   "47051T4N45N32N3" => "#CCCCF0",
	   "475TN529OC1.4OP" => "#CCCCF0",
	   "476TG6SNMNN33)" => "#CCC0F0",
	   "47617M5N39N33)" => "#DDEEF0",
	   "4717M5N39N33)" => "#CCFFF0",

	   "4611)" => "#DDFFFF",
	   "4611N4)" => "#CCEEFF",
	   "4611N3N4)" => "#CCCCFF",
	   "4611N45)" => "#AAFFFF",
	   "4611G6N4)" => "#BBEEFF",
	   "4717M5N04)" => "#CCAAFF",
	   "4717N04)" => "#CCBBFF",

#	   "Firefox/1.5.0.6" => "#FFDDFF",
#	   "5.1j Ff/1.5.0.6" => "#FFDDFF",
#	   "Firefox/1.5.0.7" => "#FFBBFF",
#	   "5.1j Ff/1.5.0.7" => "#FFBBFF",
#	   "5.0j Ff/1.5.0.7" => "#FFDDEE",
#	   "5.1j Ff/1.5.0.9" => "#FFBBFF",
#	   "5.1j Ff/2.0.0.1" => "#FFDDFF",
#	   "5.1j Ff/2.0.0.6" => "#FFDDFF",
#	   "5.1j Ff/2.0.0.7" => "#FFBBFF",
#	   "5.1j Ff/2.0.0.8" => "#FFDDEE",
	   "51jFf/200.9" => "#EEBBFF",
#	   "51jFf/303" => "#FFDDFF",
#	   "51jFf/305" =>  "#FFDDEE",
#	   "51jFf/306" =>  "#FFCCFF",
#	   "60jFf/3.0.3" => "#FFBBFF",
	   "60jFf/305" => "#FFBBFF",
#	   "5W60jFf/305" => "#FFBBFF",
#	   "5W60jFf/306" => "#FFB0FF",
#	   "51jFf/306(N39)" => "#F0C0FF",
	   "51jFf/3011(N39)" => "#FFDDFF",
	   "51jFf/3011" =>  "#FFDDEE",
	   "5W60jFf/3011(N3" => "#FFBBFF",
	   "51jFf/3012(N39)" => "#F0C0FF",
	   "51jFf/3012" =>  "#FFCCFF",
	   "5W60jFf/3012" => "#FFB0FF",
#	   "51jFf/3.5.3(N39" => "#FFDDF0",
	   "51jFf/353(N39)" => "#FFDDF0",
	   "51jFf/353" => "#FFB0FF",
#	   "5W60jFf/3014(N3" => "#FFBBF0",
	   "60jFf/3014(N39)" => "#FFBBF0",
#	   "5W60jFf/3.5.3(N" => "#FFB0F0",
	   "60jFf/353(N39)" => "#FFB0F0",
	   "51jFf/3014(N39)" => "#F0CCFF",

	   "**O/9.63 51Uja) P" => "#FFAAFD",

	   "O/9.52 51zc)" => "#CC88CC",
	   "**O/9.52 51zc)" => "#CC88CC",
	   "4611I1; 360SE)" =>  "#CC70CC",
	   "**4611I1; 360SE)" =>  "#CC70CC",
	   "O/9.60 51zc) Pr" => "#CC88B0",
	   "**O/9.60 51zc) Pr" => "#CC88B0",
	   "4611; 360SE)" =>  "#B088CC",
	   "**4611; 360SE)" =>  "#B088CC",
	   "M50L6jFf/304" => "#DDAAFF",
	   "**M50L6jFf/304" => "#DDAAFF",

	   "FF3.6 1001159.2"  => "#FFAADD", # 224
	   "**FF3.6 1001159.2"  => "#FFAADD", # 224
	   "6sG6.5)"  => "#FFAADD", # 224

	   # zj.dynamic.163data.com.cn pۂ
	   "5W51e rv:1.9) G" => "#FF8888",
	   "4611TQQ7T4IS4.3" => "#FF8888",
	   "50zC Ff/305" => "#FF8888",


	   # zj.dynamic.163data.com.cn gpɏ
	   "46050QQ7Mt)" => "#FFBBAA",
	   "4611QQ7MtIP2N57" => "#FFBBAA",
	   "4611QQ7TN3N4M4)" => "#FFBBAA",
	   "51; zh-CN)A525." => "#FFBBAA",
	   "51zC Ff/306" => "#FFBBAA",
	   "M50 (compatible" => "#FFBBAA",
	   "O/9.27 51zc)" => "#FFBBAA",
	   "51zC Ff/3013" => "#FFBBAA",

	   #
	   "51; zh-CN)A530." => "#FFBBAA",
	   "51e)A530.5K37 S" => "#FFBBAA",
#	   "51zC Ff/3.5.1" => "#FFBBAA",
	   "51zC Ff/351" => "#FFBBAA",
	   "O64 51Uen-GBPr2" => "#FFBBAA",
	   "51jJ Ns/7.02 (C" => "#FFBBAA",
	   "4611N57N38N4; 3" => "#FFBBAA",
	   "51zC)A019.2KVer" => "#FFBBAA",
	   "51e)A05K37 Sf05" => "#FFBBAA",
	   "51zC)A019.2KV4." => "#FFBBAA",
	   "46050N57)" => "#FFBBAA",
	   "486TQQ7SL1N57N3" => "#FFBBAA",
	   "4611QQ 570; 460" => "#FFBBAA",
	   "475TQQ 551T4; 4" => "#FFBBAA",
	   "51zC Ff/351(N39" => "#FFBBAA",
	   "475TG5; 4611) N" => "#FFBBAA",
	   "O80 51zcPr2.2.1" => "#FFBBAA",
	   "4611; SaaYaa)" => "#FFBBAA",
	   "51zC Ff/352" => "#FFBBAA",
	   "60zC Ff/352(N39" => "#FFBBAA",
	   "51e Ff/352 Orca" => "#FFBBAA",
	   "60e)A22KCh4.0.2" => "#FFBBAA",
	   "4611TQQ7IS4.3.5" => "#FFBBAA",
	   "M405 [en] (X11;" => "#FFBBAA",
	   "4611G6N57; AskT" => "#FFBBAA",
	   "4611N57; MAXTHO" => "#FFBBAA",
	   "51zT Ff/3014(N3" => "#FFBBAA",

	   #
	   "4611; MAXTHON 2" => "#FFBBAA",
	   "51zC Ff/3.5.2" => "#FFBBAA",
	   "O64 51UEdition " => "#FFBBAA",
	   "51zC)A531.9KVer" => "#FFBBAA",
	   "51zC)A19KV4.0.3" => "#FFBBAA",

	   # proxy
	   "M50L6e Ff/306" => "#FFAABB",
	   "M50L6; en; Ff/3" => "#FFAABB",
	   "4611QQ7; 360SE)" => "#FFAABB",
	   "4611QQ7)" => "#FFAABB",
	   "5W60jFf/306(N39" => "#FFAABB",
	   "4611; Foxy/1N57" => "#FFAABB",
	   "47051T4; Foxy/1" => "#FFAABB",
	   "46051; Foxy/1I1" => "#FFAABB",
#	   "47051; Foxy/1; " => "#FFAABB",
	   "47051Fx1; 4611)" => "#FFAABB",
	   "4611Fx1Fx1N57)" => "#FFAABB",

	   "51e)A05K43 Sf05" => "#FFAABB",
	   "5W60zC Ff/305" => "#FFAABB",
	   "5W60e)A532.0KCh" => "#FFAABB",

	   "5W60e)A05K43 Sf" => "#FFAABB",
	   "4611QQ 551)" => "#FFAABB",
#	   "51zC Ff/3.5.3" => "#FFAABB",
	   "51zC Ff/353" => "#FFAABB",
	   "O64 51zcPr2.1.1" => "#FFAABB",
#	   "5W60zC Ff/3.5.2" => "#FFAABB",
	   "5W60zC Ff/352(N" => "#FFAABB",
	   "O60 60zcPr2.1.1" => "#FFAABB",
	   "O/9.80 51zcPr2." => "#FFAABB",
	   "4611QQ7N57)" => "#FFAABB",
	   "47060G6Ua4611; " => "#FFAABB",
	   "51zT Ff/3.5.3(N" => "#FFAABB",
	   "48060T4QQ7SL1N5" => "#FFAABB",
	   "460 Windows XP)" => "#FFAABB",
	   "O60 (J2ME/MIDP;" => "#FFAABB",
	   "47T; Foxy/1; Fo" => "#FFAABB",
	   "476TSL1N57M5N04" => "#FFAABB",
	   "476TSL1N57N33N3" => "#FFAABB",
	   "47051; 4611) N5" => "#FFAABB",
	   "47051Fx1)" => "#FFAABB",
	   "475TG6)" => "#FFAABB",
	   "51zT Ff/353" => "#FFAABB",
	   "4611N729; TheWo" => "#FFAABB",
	   "4611; (R1 1.6)N" => "#FFAABB",
	   "60e)A21KCh4.0.2" => "#FFAABB",
	   "51e Ff/307" => "#FFAABB",
	   "51; en-GB; Ff/2" => "#FFAABB",
	   "60zT Ff/353(N39" => "#FFAABB",
	   "460989x)" => "#FFAABB",
	   "60; en-GB; Ff/3" => "#FFAABB",
	   "5X 10_4_11; zh-" => "#FFAABB",
	   "4611QQ 538; 460" => "#FFAABB",
	   "O/7.60 (Windows" => "#FFAABB",
	   "47060; WOW64T4S" => "#FFAABB",
	   "475T; .N CLR 2." => "#FFAABB",

	   # 1/26 ̂P
	   "Tongco2/1.20 (h" => "#FFAABB",
	   "Zuzu/1.0 (http:" => "#FFAABB",
	   "Sf328C403023W61" => "#FFAABB",
	   "761TQQ598SL2N27" => "#FFAABB",
	   "FF3.5.5 0911029" => "#FFAABB",
	   "650)" => "#FFAABB",
	   "HTTP_Controller" => "#FFAABB",
	   "DoCoMo CoDoMo" => "#FFAABB",

	   # 1/26 ̂Q
	   "Sf328C402950W61" => "#FFAAEE",

	   # 11/07/22
	   "**Sf3430C12074212" => "#FFAABB",
	   "**961T5) *powered" => "#FFAABB",
	   "Sf3430C12074212" => "#FFAABB",
	   "961T5) *powered" => "#FFAABB",
	   "961T5)" => "#FFAABB",
	   "Froute Mobile G" => "#FFAABB",
	   "M40 (compatible" => "#FFAABB",
	   "User-Agent: 760" => "#FFAABB",
	   "F353 W51eU(N359" => "#FFAABB",
	   "GodeGode/1.0 (h" => "#FFAABB",
	   "Anonemizer/1.00" => "#FFAABB",
	   "kaomoziproxy" => "#FFAABB",
	   "center net" => "#FFAABB",
	   "751; VNIE5 RefI" => "#FFAABB",
	   "Y!J-BRJ/YATS cr" => "#FFAABB",
	   "M50chttp://c7.f" => "#FFAABB",
	   "M40cKZ BRAIN Mo" => "#FFAABB",
	   "M50cPEAR HTTP_R" => "#FFAABB",
	   "Sf3414C90597 M5" => "#FFAABB",

	   # t 2/19 224
	   "**761TQQ619SL2N27" => "#FFAABB",
	   "761TQQ619SL2N27" => "#FFAABB",
	   "**FF3.5.5 0911029" => "#FFAABB",
	   "Sf331C503350W61" => "#FFAABB", # 2/26
	   "**Sf331C503350W61" => "#FFAABB",
	   "Sf2816M7A341 V4" => "#FFAABB",
	   "861)" => "#FFAABB",
	   "651)" => "#FFAABB",
	   # 5/22 224
	   "Sf339C604011W61" => "#FFAABB",
	   "M405 [en] (http" => "#FFAABB",
	   "Internet Explor" => "#FFAABB",
	   "Mediapartners-G" => "#FFAABB",
	   "Sf340C604081W61" => "#FFAABB",
	   "Sf334C5037599W5" => "#FFAABB",
	   "FF3.5.7GDFff GT" => "#FFAABB",
	   "**FF3.5.7GDFff GT" => "#FFAABB",
	   "751N729)" => "#FFAABB",
	   "**751N729)" => "#FFAABB",

	   "FF3.6.3 1004019" => "#FFAABB",
	   "Sf342C604531W61" => "#FFAABB",

	   "Sf325C412491064" => "#FFAAEE",
	   "**Sf325C412491064" => "#FFAAEE",

	   # 2/23
	   "FF3.5.6 QQDownl" => "#FFAAEE",
	   "FF3.5.6 CometBr" => "#FFAAEE",
	   "O980(J2ME/MIDP;" => "#FFAAEE",
	   "6sMt)" => "#FFAAEE",
	   "**FF3.5.6 QQDownl" => "#FFAAEE",
	   "**FF3.5.6 CometBr" => "#FFAAEE",
	   "**O980(J2ME/MIDP;" => "#FFAAEE",
	   "**6sMt)" => "#FFAAEE",

	   # 10/31
	   "F20011 W51zC" => "#FFAABB",
	   "Sf347C705190W51" => "#FFAABB",
	   "**F20011 W51zC" => "#FFAABB",
	   "**Sf347C705190W51" => "#FFAABB",

	   # 11/8
	   "6sCIN78229N13)" => "#FFAABB",
	   "F3612 W51zC(N35" => "#FFAABB",
	   "SfW51eU)A339 Ma" => "#FFAABB",
	   "F3612 W51zC" => "#FFAABB",
	   "**F3612 W51zC" => "#FFAABB",
	   "851T)" => "#FFAABB",
	   "6sG6.6N27)" => "#FFAABB",
	   "6sN14N27; TheWo" => "#FFAABB",


	   # ts

	   "M50 (en-us)A525" => "#FFAACC",
	   "O/9.27 51Uja)" => "#FFAACC",
	   "485TN4IP2N729)" => "#FFAACC",
	   "4611N57; AskTB5" => "#FFAACC",
	   "475TG6Fx1)" => "#FFAACC",
	   "47051QQ 538T4; " => "#FFAACC",
	   "475T; CIBAN57; " => "#FFAACC",
	   "476TSL1N57IP2N3" => "#FFAACC",
	   "47051QQ 570N57N" => "#FFAACC",
	   "475TT4; (R1 1.6" => "#FFAACC",
	   "4611TQQ 551)" => "#FFAACC",
	   "4611N57N32)" => "#FFAACC",
	   "460 AOL 7.0;50N" => "#FFAACC",
	   "WordPress/2.6.5" => "#FFAACC",
	   "475TN45)" => "#FFAACC",
	   "46051) Netscape" => "#FFAACC",
	   "51jFf/353G5(N39" => "#FFAAAA",
	   "475TN57N36IP2N3" => "#FFAACC",
	   "M50L6e Ff/200.1" => "#FFAACC",
	   "485TFx1Fx1I1)" => "#FFAACC",
	   "4611; CIBAN57N3" => "#FFAACC",
	   "4611QQ 590N57)" => "#FFAACC",
	   "476TQQ 584; 461" => "#FFAACC",
	   "4611QQ 590)" => "#FFAACC",
	   "476TG5QQ7SL1N57" => "#FFAACC",
	   "60e)A06KMaxthon" => "#FFAACC",
	   "60zC Ff/353(N39" => "#FFAACC",
	   "60zC)A19KV4.0.3" => "#FFAACC",
	   "60e)A20KCh4.0.2" => "#FFAACC",
	   "486TSL1N57M5TP2" => "#FFAACC",
	   "4611G6N45)" => "#FFAACC",
	   "4611Fx1Fx1N57N4" => "#FFAACC",
	   "60zT Ff/307" => "#FFAACC",
	   "460 ) O/UCWEB7." => "#FFAACC",

	   # 7/6
	   "S94861TSL2N27N3" => "#FFAACC",

	   # 8/25
#	   "Sf334C50375127W" => "#FFAACC",
	   "Sf346C604950W61" => "#FFAACC",
	   "861TSL2N27N359N" => "#FFAACC",
	   "6sQQ1.7N14N27)" => "#FFAACC",
	   "751TN729)" => "#FFAACC",
	   "6sQQ615N27; 360" => "#FFAACC",
	   "6s)" => "#FFAACC",
	   "FF3.5.11GDFff G" => "#FFAACC",

	   # 10/7
	   "Sf347C705175W61" => "#FFAACC", # <- Sf346C...

	   # 11/6 comic
	   "Sf347C7051744W6" => "#FFAACC",
	   "**Sf347C7051744W6" => "#FFAACC",

	   #

	   "48060T4SL1N57M5" => "#FFBBAA",
	   "47TSL1N57N33N39" => "#FFBBAA",

	   "4611IP2N57)" => "#FFBBAA",
	   "4611; 46051S1) " => "#FFBBAA",
	   "51zC Ff/3014" => "#FFBBAA",
	   "4611Mt)" => "#FFBBAA",

	   "47051; Foxy/1G6" => "#FFBBAA",

	   "FF3.5.11 100701" => "#FFBBAA",

	   "4611N57)" => "#FFA0BB",
	   "**4611N57)" => "#FFA0BB",
	   #

	   # fesaimoe
	   "851TY730G6.5N47" => "#FFA0BB",


	   "Netscape/7.0" => "#FFCCEE", 
	   "5.1jJ Ns/7.0" => "#FFCCEE", 
	   
	   "51e8Sf519" => "#FFC0EE", 
	   "5W60e8Sf519" => "#FFB0EE", 

	   "Mozilla/4.08 (P" => "#FFEEBB", 
	   "408 P33 NF/3.3" =>  "#FFEEBB", 
	   "DoCoMo/1.0/D501" => "#FFFFCC",

	   # 
	   "4611) O 8.7 [ja" =>  "#FFEEBB",
	   "408(PDA; SL-C32" =>  "#FFEEBB",
	   "460CE; IEMobile" =>  "#FFEEBB",
	   "441CESW4SHPP; 4" =>  "#FFEEBB",

	   # netvigator
	   "475TFx1G6; 4611" => "#A0FF88",
	   "51zT Ff/353(N39" => "#A0FF88",
	   "475TFx1Fx1N529;" => "#A0FF88",
	   "47051Fx1G6Fx1N4" => "#A0FF88",
	   "51zT Ff/353 Fox" => "#A0FF88",

	   # 
	   "441CESW7SHPP; 4" => "#88FF88",
	   "5MIX 10_5_6jj)A" => "#88FF88",
	   "4611) O 8.60 [j" => "#88FF88",
	   "**4611) O 8.60 [j" => "#88FF88",
	   "K-TS3H UP.Brows" => "#88FF88",
	   "5W Windows NT 6" => "#88FF88",
#	   "5MIX 10.5jJm; F" => "#88FF88",
	   "5X 10.5jJm; Ff/" => "#88FF88",
	   "480 Windows NT " => "#88FF88",
	   "4611) O 8.65 [j" => "#88FF88",
	   "5W51e rv:1.8.1." => "#88FF88",
#	   "O63 51UjaPr2.1." => "#88FF88",
#	   "**O63 51UjaPr2.1." => "#88FF88",

	   "O63 51UjaPr2.1." => "#D0AAFF",
	   "**O63 51UjaPr2.1." => "#D0AAFF",

	   # 
#	   "51jFf/3.5.1" => "#AAFFAA",
	   "51jFf/351" => "#AAFFAA",
	   "4611G6N57)" => "#AAFFAA",
	   "O645UP1" => "#AAFFAA",
	   "51e Ff/3.1b4pre" => "#AAFFAA",
	   "51jFf/200.17 Fl" => "#AAFFAA",
	   "51e)A05K39 Sf05" => "#AAFFAA",
	   # 
	   "51jFf/200.20" => "#AAFFAA",
	   "51jJ)A530.17KVe" => "#AAFFAA",
	   "51e)A530.9KIron" => "#AAFFAA",
	   "51jJ)A017KVersi" => "#AAFFAA",
	   "51e)A09KIron/2." => "#AAFFAA",
	   "47060G5QQ7SL1N5" => "#AAFFAA",
	   "4611T)" => "#AAFFAA",

	   # 
	   "4611Y0N529)" => "#FFA0D0",
	   "4717M5N04; MDDC" => "#FFA0D0",

	   # 226
	   "4CE SW07SH; PPC" => "#D0AAFF",
	   "751TN14N27N360N" => "#D0AAFF",
	   "751TN78229)" => "#D0AAFF",
	   "751TY730N14N27;" => "#D0AAFF",
	   "FF3.5.11 ( .NET" => "#D0AAFF",
	   "FF3.5.11(N359)" => "#D0AAFF",
	   "FF3.5.7(N359) 0" => "#D0AAFF",
	   "FF3.5.8(N359) 1" => "#D0AAFF",
	   "FF3.6.10 ( .NET" => "#D0AAFF",
	   "FF3.6.10 YTB730" => "#D0AAFF",
	   "FF3.6.8 YTB730 " => "#D0AAFF",
	   "FF3.6.8 ( .NET " => "#D0AAFF",
	   "FF3.6.9 ( .NET " => "#D0AAFF",
	   "FF3.6.9 YTB730 " => "#D0AAFF",
	   "M475 j (W50)" => "#D0AAFF",
	   "M50 (Windows; U" => "#D0AAFF",
	   "NF4.0 M50 (PDA;" => "#D0AAFF",
	   "O601 j 50Window" => "#D0AAFF",
	   "O860j 6CE SW07S" => "#D0AAFF",
	   "O980(W51j)P215" => "#D0AAFF",
	   "O980(W51j)P630 " => "#D0AAFF",
	   "Sf33178V501W51j" => "#D0AAFF",
	   "Sf334C50375127W" => "#D0AAFF",
	   "Sf343C6047262W5" => "#D0AAFF",
	   "Ls63122729 851T" => "#D0AAFF",
	   "F3611 W61j YTB7" => "#D0AAFF",
	   "F3610 W61j YTB7" => "#D0AAFF",
	   "F369 W61j YTB73" => "#D0AAFF",
	   "F368 W61j YTB73" => "#D0AAFF",
	   "F3610 W51j ( )" => "#D0AAFF",
	   "O980(W51j)P215 " => "#D0AAFF",
	   "F3610 W51j(N359" => "#D0AAFF",
	   "F363 W51j(N359)" => "#D0AAFF",
	   "F3610 W51j ( .N" => "#D0AAFF",
	   "F369 W51j ( .NE" => "#D0AAFF",
	   "F368 W51j ( .NE" => "#D0AAFF",
	   "F366 W51j ( .NE" => "#D0AAFF",
	   "F363 W51j ( .NE" => "#D0AAFF",
	   "FF3.5.11( N359)" => "#D0AAFF",
	   "F3610 W51j( N35" => "#D0AAFF",
	   "F369 W51j( N359" => "#D0AAFF",
	   "F368 W51j( N359" => "#D0AAFF",
	   "F366 W51j( N359" => "#D0AAFF",
	   "F363 W51j( N359" => "#D0AAFF",
	   "SfW51jJ)A333 Lu" => "#D0AAFF",

	   # 229
	   "**Sf2816M7E18 V40" => "#D0AAAF",
	   "Sf2816M7E18 V40" => "#D0AAAF",
	   "FF3.6.8 1007229" => "#D0AAAF",
	   "FF3.6.10 100914" => "#D0AAAF",
	   "Sf6531227M8B117" => "#D0AAAF",
	   "FF3.6.12 101026" => "#D0AAAF",
	   "F3612 W61j" => "#D0AAAF",
	   "F3612 W61j" => "#D0AAAF",
	   "F363 W51j ( .NE" => "#D0AAAF",
	   "F366 W51j ( .NE" => "#D0AAAF",
	   "F363 W51j( N359" => "#D0AAAF",
	   "F366 W51j( N359" => "#D0AAAF",
	   "F366 W61j" => "#D0AAAF",
	   "F368 W61j" => "#D0AAAF",
	   "F3610 W61j" => "#D0AAAF",
	   "F3611 W61j" => "#D0AAAF",
	   "861WOTSL2N27N35" => "#D0AAAF",

	   # 230
	   "Sf343C6047263W5" => "#AAFFAA",
	   "Sf343C6047262W5" => "#AAFFAA",

	   # 333
	   "FF3.6.6 ( .NET " => "#FFA0D0",
	   "Ns71 (ax) W51ja" => "#FFA0D0",
	   "751TN13N4729)" => "#FFA0D0",
	   "FF3.6.3(N359) 1" => "#FFA0D0",
	   "FF3.6(N359) 100" => "#FFA0D0",


	   # 11/08/24
	   # 201
	   "Ar2331IS12SH BS" => "#D0AAFF",
	   "O980(Android 2." => "#D0AAFF",

	   # ނ
	   "652; SV1)" => "#FFA0D0",
	   "851TG7.1N4729; " => "#FFA0D0",
	   "**652; SV1)" => "#FFA0D0",
	   "**851TG7.1N4729; " => "#FFA0D0",

	   # ʃM ɒǉ
	   "652; SV1N14N27)" => "#FFA0BB",

	   # tM I
	   "F20020 W51j" => "#CCFFAA",
	   "Sf3017V40W51jJ)" => "#CCFFAA",
	   "SM1117W51jJ; rv" => "#CCFFAA",
	   "F20017 W51j Flo" => "#CCFFAA",
	   "Ls51619479 F5.4" => "#CCFFAA",
	   "Sf351C130782112" => "#CCFFAA",
	   "Sf3424C11069677" => "#CCFFAA",
	   "Sf3430C12074291" => "#CCFFAA",
	   "Sf351C130782107" => "#CCFFAA",
	   "FF3.6.18 110621" => "#CCFFAA",
	   "O964(W51j)P11" => "#CCFFAA",
	   "Sf3430C1207500 " => "#CCFFAA",
	   "851TG7.1N14; As" => "#CCFFAA",

	   # 321
	   "Ls64623632 851T" => "#88FF88",

	   # 233 11/09/08
	   "in421M8C148Sf65" => "#A0FF88",

	   # 
	   "**751TN4CN4EN27N3" => "#FFAABB",
	   "751TN4CN4EN27N3" => "#FFAABB",
	   "**751TMP2N729N4C;" => "#FFAABB",
	   "751TMP2N729N4C;" => "#FFAABB",
	   "**761T5SL2N27N359" => "#FFAABB",
	   "761T5SL2N27N359" => "#FFAABB",
	   "6Windows XP)" => "#FFAABB",
	   "751; 6s) N729; " => "#FFAABB",
	   "**851TG0.0; 6s) N" => "#FFAABB",
	   "851TG0.0; 6s) N" => "#FFAABB",
	   "851TIP2N729N4C)" => "#FFAABB",
	   "851T; 6s) ; The" => "#FFAABB",
	   # ɒǉ
	   "851TN4C)" => "#FFAABB",
	   "851TN27N4CN4EN2" => "#FFAABB",
	   "6s; QQPinyin 68" => "#FFAABB",
	   "861TQQ687SL2N27" => "#FFAABB",
	   "851T; SV1; 4399" => "#FFAABB",
	   "652; SV1N14N27)" => "#FFAABB",


	   "*" => "RED",
	   "q" => "BLUE",
	   "N" => "BLUE",
	   "P80" => "#FFDDEE",
	   "P3389" => "#FFDDEE",
	   "201" => "#CCDDFF",
	   "202" => "#FFDDAA",
	   "203" => "#FFDDAA",
	   "204" => "#FFDDCC",
	   "212" => "#FFBBAA",
	   "213" => "#FFBBAA",
	   "214" => "#FFBBAA",
	   "221" => "#FF8888",
	   "184" => "#88FF88",
	   "95" => "#88FF88",

	   "E" => "#FF8888",
	   "P" => "#8888FF",
	   "chIP" => "#FFFF00",
	   "over" => "#00FFFF",
);


%ProxyMeaning = (
		 "14" => "ts",
		 "50" => "BBQ",
		 "52" => "BBQ?",
		 "60" => "SpamCop",
		 "62" => "SpamCop?",
		 "80" => "proxy",
		 "81" => "proxyϐ",
		 "82" => "HTTP_TE",
		 "298" => "֎~hC",
		 "299" => "֎~hC2",
    "P80" => "|[g(HTTP)",
    "P3389" => "|[g(VPN)",
		 );

%ErrorMeaning = (
		 "3220" => "ė\\NC",
		 "3250" => "ė\\NC",
		 "3252" => "ė\\",
		 "3253" => "ė\\",
		 "3310" => "\\\\NC",
		 "3312" => "\\\\",
		 "3322" => "\\\\OC",
		 "3634" => "s\\",
		 "3644" => "s\\",
		 "3805" => "ė\\",
		 "4411" => "\\",
		 "4451" => "\\",
		 "4455" => "җ\\",
		 "4735" => "s",
		 "4760" => "s",
		 "4761" => "ꔭs",
		 "4764" => "s",
		 "4940" => "Ҕs",
		 "9999" => "g",
		 "30" => "IC",
		 "184" => "gыK",
		 "201" => "ꎞ~",
		 "202" => "DKJn",
		 "204" => "DBKJn",
		 "212" => "DCKJn",
		 "214" => "DBCKJn",
		 "221" => "DBIK",
		 "231" => "A\\K",
		 "233" => "uEUύX",
		 "271" => "Kꎞ", 
		 "272" => "Kꎞ", 
		 "284" => "VK",
		 "401" => "g",
		 "501" => "Bُ",
		 );



#### V[U[Í
### FA炷
### ԂlFÍ
### gpݒϐF$CaesarStr
sub CaesarCrypt {
    my ($str, $key) = @_;
    my ($pt, $pos, $i, $k, $cp, $text);
    my $nstr = length($str);
    my $ncode = length($CaesarStr);
    $text = "";

    for($i=0; $i<$nstr; $i++) {
	$pt = substr($str, $i, 1);
	if ( ( $pos = index($CaesarStr, $pt) ) >= 0) {
	    $k = ($pos + $key) % $ncode;
	    $cp = substr($CaesarStr, $k, 1);
	    $text .= $cp;
	} else {
	    $text .= $pt;
	}
    }
    return($text);

}



### uEUZk
sub AbbBrowser {
    my ($str) = @_;

    # .NET Framework
    $str =~ s/; .NET CLR 1.0.3705/N13/g;
    $str =~ s/; .NET CLR 1.1.4322/N14/g;
    $str =~ s/; .NET CLR 2.0.40607/N27/g;
    $str =~ s/; .NET CLR 2.0.50215/N25/g;
    $str =~ s/; .NET CLR 2.0.50727/N27/g;
    $str =~ s/; .NET CLR 3.0.04506.30/N360/g;
    $str =~ s/; .NET CLR 3.0.04506.648/N368/g;
    $str =~ s/; .NET CLR 3.0.04506/N36/g;
    $str =~ s/; .NET CLR 3.0.30618/N38/g;
    $str =~ s/; .NET CLR 3.0.30729/N39/g;
    $str =~ s/; .NET CLR 3.0.4506.2152/N362/g;
    $str =~ s/; .NET CLR 3.5.21022/N32/g;
    $str =~ s/; .NET CLR 3.5.30729/N359/g;

    $str =~ s/ \(.NET CLR 1.0.3705/\(N13/g;
    $str =~ s/ \(.NET CLR 1.1.4322/\(N14/g;
    $str =~ s/ \(.NET CLR 2.0.40607/\(N27/g;
    $str =~ s/ \(.NET CLR 2.0.50215/\(N25/g;
    $str =~ s/ \(.NET CLR 2.0.50727/\(N27/g;
    $str =~ s/ \(.NET CLR 3.0.04506.30/\(N360/g;
    $str =~ s/ \(.NET CLR 3.0.04506.648/\(N368/g;
    $str =~ s/ \(.NET CLR 3.0.04506/\(N36/g;
    $str =~ s/ \(.NET CLR 3.0.30618/\(N38/g;
    $str =~ s/ \(.NET CLR 3.0.30729/\(N39/g;
    $str =~ s/ \(.NET CLR 3.0.4506.2152/\(N362/g;
    $str =~ s/ \(.NET CLR 3.5.21022/\(N32/g;
    $str =~ s/ \(.NET CLR 3.5.30729/\(N359/g;
    $str =~ s/ \( .NET CLR 3.5.30729/\( N359/g;

    $str =~ s/N14N27N360N368N362N359/N470829/;

    $str =~ s/N27N368N32N362N359/N78229/;
    $str =~ s/N14N27N360N362N359/N47029/;

    $str =~ s/N14N27N362N359/N4729/;

    $str =~ s/N13N14N27/N347/;
    $str =~ s/N27N362N359/N729/;
    $str =~ s/N368N362N359/N829/;

    $str =~ s/N362N359/N29/;

    $str =~ s/; .NET4.0C/N4C/; # 110824
    $str =~ s/; .NET4.0E/N4E/; # 110824

    # IEn̑
    $str =~ s/; Trident\/4.0/T/;
    $str =~ s/; Trident\/5.0/T5/;
    $str =~ s/; Media Center PC 4.0/M4/;
    $str =~ s/; Media Center PC 5.0/M5/;
    $str =~ s/; Media Center PC /MC/;
    $str =~ s/; GTB/G/;
    $str =~ s/ GTB/G/;

    $str =~ s/; SLCC/SL/;
    $str =~ s/; YTB720/Y0/;
    $str =~ s/; YTB/Y/;
    $str =~ s/; OfficeLiveConnector\./OC/;
    $str =~ s/; OfficeLivePatch\./OP/;
    $str =~ s/; iCafeMedia/iCM/g;
    $str =~ s/; InfoPath\./IP/;
    $str =~ s/; MEGAUPLOAD /ML/;
    $str =~ s/; TencentTraveler /TT/g;
    $str =~ s/; Tablet PC 2\.0/TP/;
    $str =~ s/; Alexa Toolbar/AT/;
    $str =~ s/; WOW64/WO/;
    $str =~ s/;  Embedded Web Browser from: http:\/\/bsalsa.com\//EW/;
    $str =~ s/; \(R1 1./R/;
    $str =~ s/; MEGAUPLOAD /ML/;
    $str =~ s/;MEGAUPLOAD /ML/;
    $str =~ s/Jingoo\//Jg/;
    $str =~ s/; YPC 3\./YC3/;
    $str =~ s/; WPS/WP/;
    $str =~ s/; DS_gamingharbor/Dg/;
    $str =~ s/; DS_juicyaccess/Dj/;
    $str =~ s/; eSobiSubscriber 2.0.4.16/eS/;
    $str =~ s/; Google/Gg/;
    $str =~ s/; niconico/n/;
    $str =~ s/; User-agent: /Ua/g;

    # p
    $str =~ s/; Foxy\//Fx/g;

    # 
    $str =~ s/; QQDownload /QQ/;
    $str =~ s/; QQDownload/QQ/;
    $str =~ s/; Maxthon/Mt/;
    $str =~ s/; MAXTHON/MT/;
    $str =~ s/; CIBA/CI/;

    $str =~ s/; Japanize\/1\.03/Jn/;

    #
    $str =~ s/SL1N27M5/SNM/;
    $str =~ s/SL1N27/SN/;
    $str =~ s/51G/5G/;
    $str =~ s/51T/5T/;

    # Opera, Presto
    if ( $str =~ /Opera/ ) {
	$str =~ s/(.*) Opera (\d)\.(\d+) (.*)/O$2$3$4 $1/;
	$str =~ s/^Opera\/(\d+)\.(\d+) /O$1$2/;

	$str =~ s/ Presto\/2\.(\d+)\.(\d+)/P$1$2/;
	$str =~ s/ Version\/10\.00/V/;
	$str =~ s/Nintendo //;
	$str =~ s/Macintosh; Intel Mac OS X; U/MI/;
	$str =~ s/Macintosh; PPC Mac OS X; U/MP/;
    }

    # NetFront
    if ( $str =~ /NetFront/ ) {
	$str =~ s/(.*) NetFront\/3\.(.*)/NF$2 $1/;
	$str =~ s/(.*) NetFront\/(.*)/NF$2 $1/;
    }

    # Android
    if ( $str =~ /Android/ ) {
	$str =~ s/(.*) Android (\d+)\.(\d+)\.(\d+); ja-jp; (.*)\) AppleWebKit\/(.*)(.)/Ar$2$3$4$7$5$1/;
	$str =~ s/SonyEricsson/SE/;
	$str =~ s/Build\//B/;
#	$str =~ s/(.*) Android (\d+)\.(\d+)\.(\d+); ja-jp; (.*)/Ar$2$3$4$5$1/;
    }

    # iPhone
    if ( $str =~ /iPhone/ ) {
	$str =~ s/Mozilla\/5.0 \(iPhone; U; CPU iPhone OS (\d)_(\d)_*(\d*) like Mac OS X(.*)Mobile\/(.*) Safari\/(.*)/in$1$2$3M$5Sf$6/;
	$str =~ s/Mozilla\/5.0 \(iPhone; U; CPU iPhone OS (\d)_(\d)_*(\d*) like Mac OS X(.*)/in$1$2$3/;
    }

    # iPod
    if ( $str =~ /iPod/ ) {
	$str =~ s/Mozilla\/5.0 \(iPod; U; CPU iPhone OS (\d)_(\d)_*(\d*) like Mac OS X(.*)Mobile\/(.*) Safari\/(.*)/id$1$2$3M$5Sf$6/;
	$str =~ s/Mozilla\/5.0 \(iPod; U; CPU iPhone OS (\d)_(\d)_*(\d*) like Mac OS X(.*)/id$1$2$3/;
    }

    # Safari
    if ( $str =~ /Safari/ ) {
	$str =~ s/(.*) Version\/(\d+)\.(\d+)\.*(\d*) (.*)Safari\/5(\d+)\.(\d+)\.*(\d*)/Sf$6$7$8$5V$2$3$4 $1/;
	$str =~ s/(.*) Version\/(\d+)\.(\d+)\.*(\d*) (.*)Safari\/(\d+)\.(\d+)\.*(\d*)/Sf$6$7$8$5V$2$3$4 $1/;
	$str =~ s/(.*) Chrome\/(\d+)\.(\d+)\.*(\d*)\.*(\d*) (.*)Safari\/5(\d+)\.(\d+)\.*(\d*)/Sf$7$8$9$6C$2$3$4$5 $1/;
	$str =~ s/(.*) Iron\/(\d+)\.(\d+)\.*(\d*)\.*(\d*) (.*)Safari\/5(\d+)\.(\d+)\.*(\d*)/Sf$7$8$9$6I$2$3$4$5 $1/;

	$str =~ s/ AppleWebKit\/5(\d+)\.(\d+)\.*(\d*) \(KHTML, like Gecko\)/A$1$2$3/;
	$str =~ s/ AppleWebKit\/5(\d+)\.(\d+) \(KHTML, like Gecko\)/A$1$2/;

	$str =~ s/Mobile\//M/;

	# Mac
	$str =~ s/ Mozilla\/5.0 \(Macintosh; U; Intel Mac OS X 10_/MIX/;
	$str =~ s/ Mozilla\/5.0 \(Macintosh; U; PPC Mac OS X 10_/MPX/;
	# Windows
	$str =~ s/ Mozilla\/5.0 \(Windows; U; Windows NT (\d).(\d)/W$1$2/;
	$str =~ s/Mozilla\/5.0 \(Windows; U; Windows NT (\d).(\d)/SfW$1$2/;
    }

    # ̑KHTML
    if ( $str !~ /^Sf/ && $str =~ /KHTML/ ) {
	$str =~ s/(.*) Mobile\/(.*)/Mb$2 $1/;
    }
    
    # Lunascape
    if ( $str =~ /Lunascape/ ) {
	$str =~ s/(.*); Lunascape (\d+)\.+(\d+)\.+(\d+)\.*(\d*)\)/Ls$2$3$4$5 $1/;
	$str =~ s/(.*) Lunascape\/(\d+)\.+(\d+)\.+(\d+)\.*(\d*)\)/Ls$2$3$4$5 $1/;

	$str =~ s/Gecko\//G/;
	$str =~ s/Firefox\/3\.(.*?) /F$1/;
	$str =~ s/Mozilla\/5.0 \(Windows; U; Windows NT 5\.1(.*) G20(\d+) (F.*)Lunascape\/(\d+)\.+(\d+)\.+(\d+)\.*(\d*)/Ls$4$5$6$7 $3$2$1/;
#	$str =~ s/Mozilla\/5.0 \(Windows; U; Windows NT 5\.1(.*) G20(\d+) /$2$1/;
#	$str =~ s/(.*)(F.*)Lunascape\/(\d+)\.+(\d+)\.+(\d+)\.*(\d*)/Ls$3$4$5$6 $2$1/;
    }

    # SeaMonkey
    if ( $str =~ /SeaMonkey/ ) {
	$str =~ s/(.*) SeaMonkey\/(\d+)\.(\d+)\.(\d+)/SM$2$3$4 $1/;

	$str =~ s/Gecko\//G/;

	# Windows
	$str =~ s/ Mozilla\/5.0 \(Windows; U; Windows NT (\d).(\d)/W$1$2/;
    }

    # Firefox
    if ( $str =~ /Firefox/ && $str !~ /^Ls/ ) {
	$str =~ s/(.*)UGESS\/1.6.7.2 /UG$1/;


	$str =~ s/(.*); rv:1.8.0.4\) Gecko\/20060508 Firefox\/1.5.0.4/F1504 $1/;
	$str =~ s/(.*); rv:1.8.0.11\) Gecko\/20070312 Firefox\/1.5.0.11/F15011 $1/;
	$str =~ s/(.*); rv:1.8.0.12\) Gecko\/20070508 Firefox\/1.5.0.12/F15012 $1/;

	$str =~ s/(.*); rv:1.8.1.9\) Gecko\/20071025 Firefox\/2.0.0.9/F2009 $1/;
	$str =~ s/(.*); rv:1.8.1.11\) Gecko\/20071127 Firefox\/2.0.0.11/F20011 $1/;
	$str =~ s/(.*); rv:1.8.1.12\) Gecko\/20080219 Firefox\/2.0.0.12/F20012 $1/;
	$str =~ s/(.*); rv:1.8.1.13\) Gecko\/20080311 Firefox\/2.0.0.13/F20013 $1/;
	$str =~ s/(.*); rv:1.8.1.14\) Gecko\/20080404 Firefox\/2.0.0.14/F20014 $1/;
	$str =~ s/(.*); rv:1.8.1.17\) Gecko\/20080919 Firefox\/2.0.0.17/F20017 $1/;
	$str =~ s/(.*); rv:1.8.1.20\) Gecko\/20081217 Firefox\/2.0.0.20/F20020 $1/;

	$str =~ s/(.*); rv:1.9\) Gecko\/2008052906 Firefox\/3.0/F30 $1/;
	$str =~ s/(.*); rv:1.9.0.1\) Gecko\/2008070208 Firefox\/3.0.1/F301 $1/;
	$str =~ s/(.*); rv:1.9.0.5\) Gecko\/2008120122 Firefox\/3.0.5/F305 $1/;
	$str =~ s/(.*); rv:1.9.0.6\) Gecko\/2009011913 Firefox\/3.0.6/F306 $1/;
	$str =~ s/(.*); rv:1.9.0.8\) Gecko\/2009032609 Firefox\/3.0.8/F308 $1/;
	$str =~ s/(.*); rv:1.9.0.9\) Gecko\/2009040820 Firefox\/3.0.9/F309 $1/;
	$str =~ s/(.*); rv:1.9.0.10\) Gecko\/2009042315 Firefox\/3.0.10/F3010 $1/;
	$str =~ s/(.*); rv:1.9.0.11\) Gecko\/2009060214 Firefox\/3.0.11/F3011 $1/;
	$str =~ s/(.*); rv:1.9.0.12\) Gecko\/2009070609 Firefox\/3.0.12/F3012 $1/;
	$str =~ s/(.*); rv:1.9.0.13\) Gecko\/2009073021 Firefox\/3.0.13/F3013 $1/;
	$str =~ s/(.*); rv:1.9.0.14\) Gecko\/2009082707 Firefox\/3.0.14/F3014 $1/;

	$str =~ s/(.*); rv:1.9.0.10\) Gecko\/2009042316 Firefox\/3.0.10/F3010W $1/;
	$str =~ s/(.*); rv:1.9.0.11\) Gecko\/2009060215 Firefox\/3.0.11/F3011W $1/;
	$str =~ s/(.*); rv:1.9.0.12\) Gecko\/2009070611 Firefox\/3.0.12/F3012W $1/;
	$str =~ s/(.*); rv:1.9.0.13\) Gecko\/2009073022 Firefox\/3.0.13/F3013W $1/;

	$str =~ s/(.*); rv:1.9.1\) Gecko\/20090624 Firefox\/3.5/F35 $1/;
	$str =~ s/(.*); rv:1.9.1.1\) Gecko\/20090715 Firefox\/3.5.1/F351 $1/;
	$str =~ s/(.*); rv:1.9.1.2\) Gecko\/20090729 Firefox\/3.5.2/F352 $1/;
	$str =~ s/(.*); rv:1.9.1.3\) Gecko\/20090824 Firefox\/3.5.3/F353 $1/;

	$str =~ s/(.*); rv:1.9.2.3\) Gecko\/20100401 Firefox\/3.6.3/F363 $1/;
	$str =~ s/(.*); rv:1.9.2.6\) Gecko\/20100625 Firefox\/3.6.6/F366 $1/;
	$str =~ s/(.*); rv:1.9.2.8\) Gecko\/20100722 Firefox\/3.6.8/F368 $1/;
	$str =~ s/(.*); rv:1.9.2.9\) Gecko\/20100824 Firefox\/3.6.9/F369 $1/;
	$str =~ s/(.*); rv:1.9.2.10\) Gecko\/20100914 Firefox\/3.6.10/F3610 $1/;
	$str =~ s/(.*); rv:1.9.2.11\) Gecko\/20101012 Firefox\/3.6.11/F3611 $1/;
	$str =~ s/(.*); rv:1.9.2.12\) Gecko\/20101026 Firefox\/3.6.12/F3612 $1/;

	$str =~ s/(.*); rv:2.0.1\) Gecko\/20100101 Firefox\/4.0.1/F401 $1/;
	$str =~ s/(.*); rv:5.0\) Gecko\/20100101 Firefox\/5.0/F50 $1/;
	$str =~ s/(.*); rv:6.0\.(\d+)\) Gecko\/20100101 Firefox\/6.0/F60$2 $1/;
	$str =~ s/(.*); rv:6.0\) Gecko\/20100101 Firefox\/6.0/F60 $1/;

	# Linux
	$str =~ s/Mozilla\/5.0 \(X11; U; Linux (.*)Gecko\/20......(\d\d) (.*) Firefox\/(\d)\.(\d+)\.(\d+)/FL$4$5$6 $2 $1 $3/;
	$str =~ s/Mozilla\/5.0 \(X11; U; Linux (.*)Gecko\/20....(\d\d) (.*) Firefox\/(\d)\.(\d+)\.(\d+)/FL$4$5$6 $2 $1 $3/;
	$str =~ s/(FL.*) i686; ja; rv:1\.0\.0\./$1/;
	$str =~ s/Ubuntu\//U/;

	# Mac
	$str =~ s/ Mozilla\/5.0 \(Macintosh; U; Intel Mac OS X 10\./MIX/;
	$str =~ s/ Mozilla\/5.0 \(Macintosh; U; PPC Mac OS X 10\./MPX/;

	# Windows
	$str =~ s/Mozilla\/5.0 \(Windows; U; Windows NT (\d).(\d)/W$1$2/;
	$str =~ s/Mozilla\/5.0 \(Windows; U; Win/W/;
	$str =~ s/Mozilla\/5.0 \(Windows NT (\d).(\d)/M5W$1$2/;
	

	# ̑
	$str =~ s/(.*); rv:1\.(.*)\) Gecko\/20(\d+)(.*)Firefox\/(.*)/FF$5 $3$2$1$4/;
    }

    # Netscape
    if ( $str =~ /Netscape/ ) {
	$str =~ s/(.*) Netscape\/(\d+)\.(\d+) (.*)/Ns$2$3 $4 $1/;
	$str =~ s/Gecko\/20/G/;
	# Windows
	$str =~ s/Mozilla\/5.0 \(Windows; U; Windows NT (\d).(\d); /W$1$2/;
    }

    # GranParadiso
    if ( $str =~ /GranParadiso/ ) {
	$str =~ s/(.*) GranParadiso\/(\d+)\.(\d+)\.(\d+)(.*)/GP$2$3$4 $5 $1/;
	$str =~ s/Gecko\/20/G/;
	# Windows
	$str =~ s/Mozilla\/5.0 \(Windows; U; Windows NT (\d).(\d); /W$1$2/;
    }

    # ̑Geckon
    if ( $str =~ /Gecko/ ) {
#	$str =~ s/(.*) Gecko\/20(.*)/G$2 $1/;
	# Windows
#	$str =~ s/Mozilla\/5.0 \(Windows; U; Windows NT (\d).(\d); /W$1$2/;
	# UNIX
    }

    # Sleipnir
    if ( $str =~ /Sleipnir/ ) {
	$str =~ s/(.*); Sleipnir\/2\.(\d+)\.*(\d*)\)/S$2$3$1/;
	$str =~ s/(.*) Sleipnir\/2\.(\d+)\.*(\d*)/S$2$3$1/;
    }

    # IE
    if ( $str =~ /MSIE/ ) {
	$str =~ s/Mozilla\/4.0 \(compatible; MSIE 4.01; /4/;
	$str =~ s/Mozilla\/4.0 \(compatible; MSIE 5.(\d+); /5$1/;
	$str =~ s/Mozilla\/4.0 \(compatible; MSIE (\d).0; /$1/g;
	$str =~ s/Mozilla\/5.0 \(compatible; MSIE 9.0; /9/g;
	
	$str =~ s/Windows NT (\d)\.(\d)/$1$2/g;
	$str =~ s/51; SV1/s/g;

	$str =~ s/Windows 98/98 /;
	$str =~ s/Windows CE/CE /;
	$str =~ s/ ; Win 9x 4.90/x/;

	$str =~ s/; IEMobile (\d+)\.(\d+)/IM$1$2/;
    }

    # Monazilla
    $str =~ s/Monazilla\/1\.00 /Mn/;

    # PDA
    $str =~ s/\(PDA; NF33PPC3AR\/1.0\)/ P33/;
    $str =~ s/; SHARP\/WS0/SW/;
    $str =~ s/; SHARP\/S0/SS/;
    $str =~ s/WILLCOM/WC/;
    $str =~ s/c100;TB;W/cW/;


    # 
    $str =~ s/; ja-jp/jj/;
    $str =~ s/; ja-JP/jJ/;
    $str =~ s/; en-us/eu/;
    $str =~ s/; en-US/eU/;
    $str =~ s/; en-GB/eG/;
    $str =~ s/; zh-cn/zc/;
    $str =~ s/; zh-CN/zC/;
    $str =~ s/; zh-tw/zt/;
    $str =~ s/; zh-TW/zT/;

    $str =~ s/; ja/j/;
    $str =~ s/; en/e/;
    $str =~ s/; zc/c/;
    $str =~ s/\-mac/m/;
    $str =~ s/\[ja\]/j/;

    # ̑
    $str =~ s/Mozilla\/5.0 \(Macintosh; U; Intel Mac OS X/MIX/;
    $str =~ s/Mozilla\/5.0 \(Macintosh; U; PPC Mac OS X/MPX/;
    $str =~ s/Mozilla\/5.0 \(X11; U; Linux /Ln/;
    $str =~ s/Windows NT (\d).(\d); U/W$1$2/;
    $str =~ s/\) AppleWebKit\/5(\d+).(\d+)\.*(\d*) \(KHTML, like Gecko\)/A$1$2$3/;
    $str =~ s/\) AppleWebKit\/(\d+).(\d+)\.*(\d*) \(KHTML, like Gecko\)/A$1$2$3/;

    $str =~ s/Mozilla\/(\d).(\d) \(compatible; /M$1$2c/; 
    $str =~ s/Mozilla\/(\d).(\d)/M$1$2/; 

    # 110824
    $str =~ s/; MathPlayer 2.0/MP2/;

    # DoCoMo
    $str =~ s/DoCoMo\//D/;
    $str =~ s/D2.0 /D2/;

    # au
    $str =~ s/KDDI/K/;
    $str =~ s/UP.Browser\/6.2.0.//;
    
    # softbank
    $str =~ s/Vodafone\/1.0\//V1/;
    $str =~ s/SoftBank\/1.0\//S1/;

    # Zk
    $str =~ s/^(.{15}).*/$1/;

    return($str);
}


sub SetRemoteDomain {

    my $tmpip = $_[0];
    my $OverSea = 0;

    $RemoteDomain = $tmpip;
    $RemoteHost = $tmpip;
    if ( $RemoteDomain =~ /jp$/ ) {
	$RemoteDomain =~ s/.*\.(.+?\..+?\.jp)$/$1/;
	if ( $RemoteDomain !~ /\...\.jp/ ) {
	    $RemoteDomain =~ s/.*\.(.+?\..+?)$/$1/;
	    if ( !$DomainPlace{$RemoteDomain} ) {
		$DomainPlace{$RemoteDomain} = 2;
	    }
	}
    } elsif ( $RemoteDomain =~ /cn$/ ) { # 
	$RemoteDomain =~ s/.*\.(.+?\..+?\.cn)$/$1/;
    } elsif ( $RemoteDomain =~ /tw$/ ) { # p
	$RemoteDomain =~ s/.*\.(.+?\..+?\.tw)$/$1/;
    } elsif ( $RemoteDomain =~ /hk$/ ) { # `
	$RemoteDomain =~ s/.*\.(.+?\..+?\.hk)$/$1/;
    } elsif ( $RemoteDomain =~ /\....$/ ) {
	$RemoteDomain =~ s/.*\.(.+?\..+?)$/$1/;
	if ( !$DomainPlace{$RemoteDomain} ) {
	    $DomainPlace{$RemoteDomain} = 2;
	}
    } else {
#	$RemoteDomain =~ s/.*\.(.+?\..+?\...)$/$1/;
	$RemoteDomain =~ s/.*\.(.+?\...)$/$1/;
	$OverSea = 1;
    }

    $RemoteDomain2 = $tmpip;
    if ( $RemoteDomain eq "bbtec.net" ) {
	$RemoteDomain2 =~ s/softbank(\d\d\d\d\d\d)\d*\./$1\./;
    } elsif ( $RemoteDomain eq "hi-ho.ne.jp" ) {
	$RemoteDomain2 =~ s/^(...).*\.(.+?\..+?\..+?\..+?)$/$1\.$2/;
#    } elsif ( $RemoteDomain eq "hinet.net" ) {
#	$RemoteDomain2 =~ s/^(\d*)\-.*\.(.+?\..+?\..+?)$/$1\.$2/;
    } elsif ( $RemoteDomain eq "infoweb.ne.jp" ) {
	if ( $RemoteDomain2 =~ /\.nt\./ || $RemoteDomain2 =~ /\.te\./ ) {
	    $RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?\..+?\..+?\..+?\..+?)$/$1/;
	} elsif ( $RemoteDomain2 =~ /^airh/ ) {
	    $RemoteDomain2 =~ s/\d//g;
	    $RemoteDomain2 =~ s/mobile\.//;
	} else {
	    $RemoteDomain2 =~ s/^(....).*\.(.+?\..+?\..+?\..+?\..+?)$/$1\.$2/;
	}
    } elsif ( $RemoteDomain eq "mesh.ad.jp" ) {
	$RemoteDomain2 =~ s/^(...).*\.(.+?\..+?\..+?\..+?)$/$1\.$2/;
	$RemoteDomain2 =~ s/^flh/fl1/;
    } elsif ( $RemoteDomain eq "ocn.ne.jp" ) {
	if ( $RemoteDomain2 =~ /^p\d+?-(.+?)\d+(.+?\..+?\..+?\..+?\..+?)$/ ) {
	    $RemoteDomain2 = "$1-$2";
	    $RemoteDomain2 =~ s/^adsau-honb/adsau-hon/;
	    $RemoteDomain2 =~ s/^adsan-honb/adsau-hon/;
	}
	$RemoteDomain2 =~ s/\d//g;
    } elsif ( $RemoteDomain eq "odn.ad.jp"  || $RemoteDomain eq "odn.ne.jp" ) {
	if ( $RemoteDomain2 =~ /cidr.odn.ne.jp/ ) { # 09/08/24 ǉ
	    $RemoteDomain2 = "cidr.odn.ne.jp";
	} else {
	    $RemoteDomain2 =~ s/^(.....).*\.(.+?\..+?\..+?\..+?)$/$1\.$2/;
	}
#	} elsif ( $RemoteDomain eq "prin.ne.jp" ) {
#	    $RemoteDomain2 =~ s/^(....).*\.(.+?\..+?\..+?\..+?)$/$1\.$2/;
#	    $RemoteDomain2 =~ s/kd12/p061/;
#	    $RemoteDomain2 =~ s/p125/p061/;
    } elsif ( $RemoteDomain eq "zaq.ne.jp" ) {
	$RemoteDomain2 =~ s/^zaq(...).*\.(.+?\..+?\..+?)$/$1\.$2/;
    } elsif ( $RemoteDomain eq "plala.or.jp" ) {
	if ( $RemoteDomain2 =~ /^i/ ) {
	    $RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?\..+?\..+?\..+?)$/$1/;
	} else {
	    $RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?\..+?)$/$1/;
	}
    } elsif ( $RemoteHost =~ /eacc\.dti\.ne\.jp$/ ) {
	$RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?\..+?\..+?)$/$1/;
    } elsif ( $RemoteHost =~ /east\.flets\.alpha-net\.ne\.jp$/ ) {
	$RemoteDomain2 = "east.bflets.alpha-net.ne.jp";
    } elsif ( $RemoteHost =~ /(em.).*\.e-mobile\.ne\.jp$/ ) {
	$RemoteDomain2 = "$1.e-mobile.ne.jp";
    } elsif ( $RemoteHost =~ /(\D\D\D\d)\.eonet\.ne\.jp$/ ) {
	$RemoteDomain2 = "$1.eonet.ne.jp";
    } elsif ( $RemoteHost =~ /.*\..(.+?)\.vectant\.ne\.jp$/ ) { # 11/08/24 ǉ
	$RemoteDomain2 = "$1.vectant.ne.jp";
	$RemoteDomain2 =~ s/\d//g;
    } elsif ( $DomainPlace{$RemoteDomain} == 2 ) {
	$RemoteDomain2 =~ s/.*\.(.+?\..+?)$/$1/;
    } elsif ( $DomainPlace{$RemoteDomain} == 3 ) {
	$RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?)$/$1/;
    } elsif ( $DomainPlace{$RemoteDomain} == 4 ) {
	$RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?\..+?)$/$1/;
    } elsif ( $DomainPlace{$RemoteDomain} == 5 ) {
	$RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?\..+?\..+?)$/$1/;
    } elsif ( $DomainPlace{$RemoteDomain} == 6 ) {
	$RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?\..+?\..+?\..+?)$/$1/;
    } elsif ( $DomainPlace{$RemoteDomain} == 7 ) {
	$RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?\..+?\..+?\..+?\..+?)$/$1/;
    } elsif ( $RemoteHost =~ /bj\-cnc$/ ) {
	$RemoteDomain2 = "bj-cnc";
    } elsif ( $RemoteHost =~ /BJ\-CNC$/ ) {
	$RemoteDomain2 = "bj-cnc";
    } elsif ( $OverSea ) {
	$RemoteDomain2 =~ s/.*\.(.+?\..+?)$/$1/;
    } else {
	$RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?)$/$1/;
    }
    if($RemoteDomain !~ /jp$/ &&
       length($RemoteDomain) > 20 &&
       length($RemoteDomain2) > 20) {
	$RemoteDomain =~ s/.*(..........)$/$1/;
	$RemoteDomain2 = $RemoteDomain;
    }
    
    if ( $RemoteDomain2 =~ /ppp.dion/ ) {
	@tmpdion = split(/\./, $RemoteHost);
	$tmpdion[0] =~ s/\d\d\d$//;
	if ( $dionp{$tmpdion[0]} ) {
	    $dionprefix = $dionp{$tmpdion[0]};
	    $dionprefix =~ s/\d$//;
	    $RemoteDomain2 = "$dionprefix" . "." . $RemoteDomain2;
	}
    }

    if ( $RemoteDomain2 =~ /ppp\-bb.dion/ ) {
	@tmpbbdion = split(/\./, $RemoteHost);
	$tmpbbdion[0] =~ s/\d\d\d$//;
	if ( $bbdionp{$tmpbbdion[0]} ) {
	    $bbdionprefix = $bbdionp{$tmpbbdion[0]};
	    $bbdionprefix =~ s/\d$//;
	    $RemoteDomain2 = "$bbdionprefix" . "." . $RemoteDomain2;
	}
    }

    if ( $RemoteDomain2 eq "dy.bbexcite.jp" ) {
	@tmpexcite = split(/\./, $RemoteHost);
	if ( $excitep{"$tmpexcite[3].$tmpexcite[2].$tmpexcite[1]"} ) {
	    $RemoteDomain2 = $excitep{"$tmpexcite[3].$tmpexcite[2].$tmpexcite[1]"} . "." . $RemoteDomain2;
	}
    }

    if ( $RemoteDomain2 eq "eo.eaccess.ne.jp" ) {
	@tmpeaccess = split(/\./, $RemoteHost);
	if ( $eaccessp{"$tmpeaccess[1].$tmpeaccess[2]"} ) {
	    $RemoteDomain2 = $eaccessp{"$tmpeaccess[1].$tmpeaccess[2]"} . "." . $RemoteDomain2;
	}
    }

    if ( $RemoteDomain2 eq "home.ne.jp" ) {
	@tmphome0 = split(/\./, $RemoteHost);
	@tmphome1 = split(/\-/, $tmphome0[0]);
	if ( $homep{"$tmphome1[0]-$tmphome1[1]-$tmphome1[2]"} ) {
	    $RemoteDomain2 = $homep{"$tmphome1[0]-$tmphome1[1]-$tmphome1[2]"} . ".rev." . $RemoteDomain2;
	}
    }

    if ( $RemoteDomain2 =~ /yournet.ne.jp$/ ) {
	@tmpyournet = split(/\./, $RemoteHost);
	if ( $yournetp{"$tmpyournet[3].$tmpyournet[2].$tmpyournet[1]"} ) {
	    $RemoteDomain2 = $yournetp{"$tmpyournet[3].$tmpyournet[2].$tmpyournet[1]"} . ".yournet.ne.jp";
	}
    }

    if ( $RemoteDomain2 =~ /ppp.wakwak.ne.jp$/ ) {
	@tmpwakwak = split(/\./, $RemoteHost);
	if ( $wakwakp{"$tmpwakwak[1]"} ) {
	    $RemoteDomain2 = $wakwakp{"$tmpwakwak[1]"} . ".wakwak.ne.jp";
	}
    }



}

### Domain2, Browser, Host, Cellphone
sub SetRemoteDBI {
    my (@tmp) = @_;

    my $tmpdb1 = "$tmp[0]<>$tmp[1]";
    my $tmpdb2 = "$tmp[0]<>*";
    my $tmpdb3 = "*<>$tmp[1]";
    $RemoteDBI = $DBIdentify{$tmpdb1};
    if ( !$RemoteDBI ) {
	$RemoteDBI = $DBIdentify{$tmpdb2};
    }
    if ( !$RemoteDBI ) {
	$RemoteDBI = $DBIdentify{$tmpdb3};
    }
    if ( $DBIdentifyIP{$tmp[2]} ) {
	$RemoteDBI = $DBIdentifyIP{$tmp[2]};
    }
    if ( !$RemoteDBI ) {
	$RemoteDBI = $DBIdentifyC{$tmp[3]};
    }
    if ( !$RemoteDBI && $tmp[1] =~ /;icc89811000(\d{11})/ ) {
	if($DBIdentifyC{$1}) {
	    $RemoteDBI .= "-" . $DBIdentifyC{$1};
	}
    }
    
    foreach (@ForbiddenDomain) {
	if ( $_ && $tmp[2] =~ /$_/ ) {
	    $RemoteDBI .= "-98";
	}
    }
    foreach (@ForbiddenDB) {
	if ( $_ && $_ eq $tmpdb1 ) {
	    $RemoteDBI .= "-97";
	}
    }
    foreach (@ForbiddenC) {
	if ( $_ && $_ eq $tmp[3] ) {
	    $RemoteDBI .= "-96";
	}
    }

    if ( $CheckCellRegulation ) {
	my $Allowed = 2;
	if ( $tmp[2] =~ /docomo.ne.jp/ ) {
	    $Allowed = 0;
	    foreach (@AllowedD) {
		if ( $_ && $_ eq $tmp[3] ) {
		    $Allowed = 1;
		}
	    }
	} elsif ( $tmp[2] =~ /ezweb.ne.jp/ ) {
	    $Allowed = 0;
	    foreach (@AllowedA) {
		if ( $_ && $_ eq $tmp[3] ) {
		    $Allowed = 1;
		}
	    }
	} elsif ( $tmp[2] =~ /jp-..ne.jp/ ) {
	    $Allowed = 0;
	    foreach (@AllowedV) {
		if ( $_ && $_ eq $tmp[3] ) {
		    $Allowed = 1;
		}
	    }
	}
	if ( !$Allowed ) {
	    $RemoteDBI .= "-95";
	}
    }

    $RemoteDBI =~ s/^\-//;
}


sub SetTimeValue {
    my $AccessTime = time;
    my ($sec,$min,$hour,$mday,$mon,$year) = localtime($AccessTime);

    if ( $hour == 23 && $min > 30) {
	my ($nmday,$nmon,$nyear) = (localtime($AccessTime+3600))[3..5];
	$TodayYMD = sprintf("%02d%02d%02d", $nyear-100, $nmon+1, $nmday);
    } else {
	$TodayYMD = sprintf("%02d%02d%02d", $year-100, $mon+1, $mday);
    }
}

(1);
