use Socket;
require './codeconfig.cgi';

# @PortScanList = (80, 8080, 3128, 1080, 8000);
@PortScanList = (80, 81, 1080, 3120, 3128, 8000, 8080, 8081, 8888, 10080, 
		 1723, 3389);
@alllist = ();

if($ARGV[0]) {
    $TodayYMD = $ARGV[0];
} else {
    &SetTimeValue;
}

# $BM=Ls!&H/9T%U%!%$%k(B
$IssuedListFileP = $IssuedListFileHeader . "p" . $TodayYMD . ".dat"; # PC$BH/9TMQ(B

print "$IssuedListFileP\n";
if(-e $IssuedListFileP) {
    open(ILF, "$IssuedListFileP");
} elsif (-e "log/$IssuedListFileP") {
    open(ILF, "log/$IssuedListFileP");
} else {
    print "no files\n";
}

# $B5,@)$7$?$$%3!<%I(B
open(CC, "kiseicodes.txt");
while(<CC>) {
    chop;
    $KiseiCode{$_} = 1;
}
close(CC);

open(KL, "> kiseilist2.txt");
while(<ILF>) {
    chop;
    @NewCodeData = split(/<>/);
    if ( $KiseiCode{$NewCodeData[13]} ) {
	print KL "$NewCodeData[13]\n";
	print KL "\"$NewCodeData[2]\",\n";
	print KL "\"$NewCodeData[15]<>$NewCodeData[4]\",\n";
	$portcheck = "";
	foreach $p (@PortScanList) {
	    if ( &ScanPortHost($p, $NewCodeData[2]) ) {
		$portcheck .= "$p ";
	    }
	}
	if ( $portcheck ) {
	    print KL "PROXY: open port $portcheck\n";
	}
	print KL "\n";
    }
}
close(KL);
close(ILF);

sub SetTimeValue {
    my $AccessTime = time;
    my ($sec,$min,$hour,$mday,$mon,$year) = localtime($AccessTime);

    if ( $hour == 23 && $min > 30) {
	my ($nmday,$nmon,$nyear) = (localtime($AccessTime+3600))[3..5];
	$TodayYMD = sprintf("%02d%02d%02d", $nyear-100, $nmon+1, $nmday);
    } else {
	$TodayYMD = sprintf("%02d%02d%02d", $year-100, $mon+1, $mday);
    }
}

#### $B%]!<%H%9%-%c%s(B
sub ScanPortHost {
    my ($port, $rhost) = @_;
    my ($tmpsock, $raddr);

    my ($hname, $aliases, $addrtyp, $length, @addrs) = gethostbyname($rhost);

    eval {
	local $SIG{ALRM} = sub { die "ERROR_TIMEOUT"; };
	alarm 1;
	$tmpsock = pack_sockaddr_in($port, $addrs[0]);
	socket(SOCKET, PF_INET, SOCK_STREAM, 0) || die "ERROR_SOCKET";
	connect(SOCKET, $tmpsock) || die "PORT_ERROR";
	alarm 0;
    };
    alarm 0;
    close(SOCKET);
    if ( $@ ) {
	return 0;
    }
    return 1;
}

