# tracert $B1gMQ(B

require './codeconfig.cgi';

@alllist = ();

if($ARGV[0]) {
    $TodayYMD = $ARGV[0];
} else {
    &SetTimeValue;
}

# $BM=Ls!&H/9T%U%!%$%k(B
$IssuedListFile = $IssuedListFileHeader . $TodayYMD . ".dat";        # PC$BM=LsMQ(B

print "$IssuedListFile\n";
if(-e $IssuedListFile) {
    open(ILF, "$IssuedListFile");
} elsif (-e "log/$IssuedListFile") {
    open(ILF, "log/$IssuedListFile");
} else {
    print "no files\n";
}
open(TL, "> trace.bat");
while(<ILF>) {
    chop;
    @NewCodeData = split(/<>/);
    if(!&CheckRemoteDomain($NewCodeData[2])) {
	print TL "tracert -h 20 $RemoteHost\n";
    }
}
close(TL);
close(ILF);

sub SetTimeValue {
    my $AccessTime = time;
    my ($sec,$min,$hour,$mday,$mon,$year) = localtime($AccessTime);

    if ( $hour == 23 && $min > 30) {
	my ($nmday,$nmon,$nyear) = (localtime($AccessTime+3600))[3..5];
	$TodayYMD = sprintf("%02d%02d%02d", $nyear-100, $nmon+1, $nmday);
    } else {
	$TodayYMD = sprintf("%02d%02d%02d", $year-100, $mon+1, $mday);
    }
}

sub CheckRemoteDomain {

    $RemoteHost = $_[0];
    
    if ( $RemoteHost =~ /ppp.dion/ ) {
	@tmpdion = split(/\./, $RemoteHost);
	$tmpdion[0] =~ s/\d\d\d$//;
	return($dionp{$tmpdion[0]});
    } elsif ( $RemoteHost =~/dy.bbexcite.jp/ ) {
	@tmpexcite = split(/\./, $RemoteHost);
	return($excitep{"$tmpexcite[3].$tmpexcite[2].$tmpexcite[1]"});
    } elsif ( $RemoteHost =~ /eo.eaccess.ne.jp/ ) {
	@tmpeaccess = split(/\./, $RemoteHost);
	return($eaccessp{"$tmpeaccess[1].$tmpeaccess[2]"});
    } elsif ( $RemoteHost =~ /home.ne.jp/ ) {
#	if( $RemoteHost =~ /^125\-14\-149|116\-65\-139/ ) {
#	    return(1);
#	}
	@tmphome0 = split(/\./, $RemoteHost);
	@tmphome1 = split(/\-/, $tmphome0[0]);
	return($homep{"$tmphome1[0]-$tmphome1[1]-$tmphome1[2]"});
    } elsif ( $RemoteHost =~ /yournet.ne.jp/ ) {
	@tmpyournet = split(/\./, $RemoteHost);
	return($yournetp{"$tmpyournet[3].$tmpyournet[2].$tmpyournet[1]"});
    }

    return(1);
}
