#### ホワイトリストのチェック
#### プロキシチェックが厳しすぎてプロキシでないのに取れない場合は
#### ホワイトリストファイルにホスト名を追加する
#### ホワイトリストファイルにホスト名のある場合は１を返し、ない場合は０を返す
### 参照大域変数：$RemoteHost
### 返り値：ホワイトリストファイルにホスト名があれば1、なければ0
### 入力ファイル：$ProxyWhiteListFile
### 呼出：&CheckProxy
### サブネットマスクは使わない
sub CheckProxyWhiteList {
	return if (!$UseProxyWhiteList);

	foreach (@ProxyWhiteList) {
		return(1) if ($_ eq $RemoteHost);  # リモートホスト名が一致
		return(1) if ($_ eq $RemoteDomain2);  # ドメイン２が一致

	}

	return(0);
}

(1);
